/*
 * Copyright (c) 1996-1997 Vectaport Inc.
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The copyright holders make
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 */

#ifndef demviewer_h
#define demviewer_h

#ifdef VTK

#include <OverlayUnidraw/ovviewer.h>

#include <IV-2_6/_enter.h>

class LODActor;
class vtkRenderer;
class vtkRenderWindow;

class DemViewer : public OverlayViewer {
public:
    DemViewer(
        Editor*, GraphicView*, UPage*, Grid* = nil, 
        Coord = 0, Coord = 0, Orientation = Normal,
	Alignment = Center, Zooming = Binary
    );
    virtual ~DemViewer();

    virtual void Draw();
    virtual void Redraw(Coord, Coord, Coord, Coord);
    virtual void Resize();

    virtual void StartBuffering();
    virtual void FinishBuffering(boolean);

    vtkRenderWindow* GetRenderWindow() { return _renWindow; }
    vtkRenderer* GetRenderer() { return _ren; }
    void CaptureOn() { _capture_on = true; _framenum = 0; }
    void CaptureOff() { _capture_on = false; }
    void ToggleRouteCapture() { _rte_capture = !_rte_capture; }
    boolean RouteCapture() { return _rte_capture; }
    void LastXY(float& x, float& y) { x = _lastx; y = _lasty; }
    void SetLastXY(float x, float y)
      { _lastx = x; _lasty = y; _lastxyset = true; }
    boolean LastXYSet() { return _lastxyset; }
  void AddActor(LODActor*);
protected:
  void UpdateCameraFootprint();
  virtual void UpdateMagnifVar();
    vtkRenderWindow* _renWindow;
    vtkRenderer* _ren;
    boolean _capture_on;
    boolean _rte_capture;
    int _framenum;
    float _lastx, _lasty;
    boolean _lastxyset;
};

#include <IV-2_6/_leave.h>

#endif

#endif
