/*
 * Copyright (c) 1994 Vectaport Inc., Cartoactive Systems
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The copyright holders make
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 */

#include <Dlg/dlgdb.h>
#include <Dlg/dlglib.h>

#include <OS/directory.h>
#include <OS/string.h>

#include <string.h>

/*****************************************************************************/

DlgDatabase::DlgDatabase (const char* path) : MapDatabase(nil, path) {
  char* p = strrchr(path, '/');
  if (p)
    _name = strdup(p+1);
  else
    _name = strdup(path);
    if (strcmp(_name, "100k_dlg")==0)
	_100k = true;
    else
	_100k = false;
}

DlgDatabase::~DlgDatabase () {}

DlgLibrary* DlgDatabase::library(unsigned libnum) const {
    return (DlgLibrary*)MapDatabase::library(libnum);
}

DlgLibrary* DlgDatabase::library(const char* name) const {
    return (DlgLibrary*)MapDatabase::library(name);
}

char** DlgDatabase::library_names (int &nlibs) const {
    return dir_names(_path, nlibs);
}

MapLibrary* DlgDatabase::make_library (const char* name) {
    return new DlgLibrary(this, name);
}

